<?php

/***************************************************************************\
 *  Plugin Statistiques pour les brves                          	   	 *
 *                                                                         *
 *  Copyright (c) 2007-2008                                                *
 *  Elrik - Peetdu														 *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
\***************************************************************************/

include_spip('inc/meta');

$version=0.85;

function STB_get_base_state() {
	$base_struct = array('visites' => false, 
				   'table_visites_breves' => false);

	// check visites in table spip_breves
	$query = "SHOW COLUMNS FROM spip_breves LIKE 'visites'";
	$result = spip_query($query);
	if (spip_num_rows($result) == 1) {
		$base_struct['visites'] = true;
	}

	// check table visites_breves
	$query = "SHOW TABLES LIKE 'spip_visites_breves'";
	$result = spip_query($query);
	if (spip_num_rows($result) == 1) {
		$base_struct['table_visites_breves'] = true;
	}

	return $base_struct;
}

function STB_set_base() {
	$base_struct = STB_get_base_state();

	// set column visites
	if ($base_struct['visites'] == false) {
		$query = "ALTER TABLE spip_breves ".
			"ADD COLUMN visites INT UNSIGNED NOT NULL DEFAULT 0";
		spip_query($query);
	}

	// create table spip_visites_breves
	if ($base_struct['table_visites_breves'] == false) {
		$query = "CREATE TABLE spip_visites_breves (".
			"id_breve INT UNSIGNED NOT NULL, ".
			"date DATE NOT NULL, ".
			"visites INT UNSIGNED NOT NULL DEFAULT 0, ".
			"maj TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ".
			"ON UPDATE CURRENT_TIMESTAMP )";
		spip_query($query);
		$query = "ALTER TABLE spip_visites_breves ADD CONSTRAINT ".
			"PRIMARY KEY (id_breve, date)";
		spip_query($query);
	}
}

function STB_set_metas() {
	ecrire_meta('stats_breves_version', $version);
	ecrire_metas();
}

function STB_del_metas() {
	effacer_meta('stats_breves_version');
	ecrire_metas();
}

function STB_reset() {
	$query = "UPDATE spip_breves SET visites = 0";
	spip_query($query);
}

function STB_RaZ() {
	$base_struct = STB_get_base_state();
	if ($base_struct['visites'] == true) {
		$query = "ALTER TABLE DROP COLUMN visites";
		spip_query($query);
	}
	if ($base_struct['referers'] == true) {
		$query = "ALTER TABLE DROP COLUMN referers";
		spip_query($query);
	}
}


/*
 * (de)Install plugin manager
 */

function stats_breves_install($action) {
	switch ($action) {
	case 'test':
		return false;
		break;
	case 'install':
		spip_log("BREVES : install plugin stats_breves");
		STB_set_base();
		STB_set_metas();
		break;
	case 'uninstall':
		spip_log("BREVES : deinstall plugin stats_breves");
		// do not drop field here because all stats will be lost
		STB_del_metas();
		break;
	}
}

?>